//------------------------------------------------------------//
//                                                            //
//  ~NX                                                //
//                                                            //
//	Hiromu Itoh     2006                                      //
//                                                            //
//------------------------------------------------------------//
import java.awt.*;

public class Cylinder
{
	private Face face[];

	public Cylinder()
	{
		this(2.0, 1.0, 16);
	}

	public Cylinder(double height, double radius, int division)
	{
		face = new Face[division * 4];

		Vector3d vertices[] = new Vector3d[Face.NUM_VERTEX];
		Vector3d uc = new Vector3d(0.0, height / 2.0, 0.0);
		Vector3d lc = new Vector3d(0.0, -height / 2.0, 0.0);
		for (int i = 0; i < division; i++) {

			// 4̓_߂
			Vector3d ul = new Vector3d(radius * Math.cos(Math.toRadians(i * 360.0 / division)), height / 2.0, -radius * Math.sin(Math.toRadians(i * 360.0 / division)));
			Vector3d ur = new Vector3d(radius * Math.cos(Math.toRadians((i+1) * 360.0 / division)), height / 2.0, -radius * Math.sin(Math.toRadians((i+1) * 360.0 / division)));
			Vector3d ll = new Vector3d(radius * Math.cos(Math.toRadians(i * 360.0 / division)), -height / 2.0, -radius * Math.sin(Math.toRadians(i * 360.0 / division)));
			Vector3d lr = new Vector3d(radius * Math.cos(Math.toRadians((i+1) * 360.0 / division)), -height / 2.0, -radius * Math.sin(Math.toRadians((i+1) * 360.0 / division)));

			// 
			vertices[0] = new Vector3d(uc);
			vertices[1] = new Vector3d(ul);
			vertices[2] = new Vector3d(ur);
			face[i] = new Face(vertices);

			// 
			vertices[0] = new Vector3d(lc);
			vertices[1] = new Vector3d(lr);
			vertices[2] = new Vector3d(ll);
			face[division + i] = new Face(vertices);

			// 
			vertices[0] = new Vector3d(ul);
			vertices[1] = new Vector3d(ll);
			vertices[2] = new Vector3d(lr);
			face[division * 2 + i] = new Face(vertices);
			vertices[0] = new Vector3d(lr);
			vertices[1] = new Vector3d(ur);
			vertices[2] = new Vector3d(ul);
			face[division * 3 + i] = new Face(vertices);

		}
	}

	public void setDiffuse(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setDiffuse(color);
		}
	}

	public void setDiffuse(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setDiffuse(red, green, blue);
		}
	}

	public void setAmbient(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setAmbient(color);
		}
	}

	public void setAmbient(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setAmbient(red, green, blue);
		}
	}

	public void setLineColor(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setLineColor(color);
		}
	}

	public void setLineColor(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setLineColor(red, green, blue);
		}
	}

	public void persDraw(Vector2d winCenter, Vector2d winScale, Matrix4x4d persM, Matrix4x4d modelM, Matrix4x4d rotM, Vector3d viewPos, Vector3d lightDir, Graphics g)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].persDraw(winCenter, winScale, persM, modelM, rotM, viewPos, lightDir, g);
		}
	}

	public void persDrawLine(Vector2d winCenter, Vector2d winScale, Matrix4x4d persM, Matrix4x4d modelM, Vector3d viewPos, Graphics g)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].persDrawLine(winCenter, winScale, persM, modelM, viewPos, g);
		}
	}
}
