//------------------------------------------------------------//
//                                                            //
//  NX                                                  //
//                                                            //
//	Hiromu Itoh     2006                         	          //
//                                                            //
//------------------------------------------------------------//
import java.awt.*;

public class Sphere
{
	private Face face[];

	public Sphere()
	{
		this(1.0, 8, 16);
	}

	public Sphere(double radius, int vdivision, int hdivision)
	{
		face = new Face[2 * (vdivision - 1) * hdivision];

		Vector3d vertices[] = new Vector3d[Face.NUM_VERTEX];

		// ŏ㕔̓_
		Vector3d uc = new Vector3d(0.0, radius, 0.0);
		// ŉ̓_
		Vector3d lc = new Vector3d(0.0, -radius, 0.0);

		int index = 0;
		double theta, phi1, phi2;

		// ŏ㕔̑
		theta = Math.toRadians(180.0 / (double)vdivision);
		for (int j = 0; j < hdivision; j++) {

			phi1 = Math.toRadians(360.0 / (double)hdivision) * j;
			phi2 = Math.toRadians(360.0 / (double)hdivision) * (j + 1);

			Vector3d ll = new Vector3d(radius * Math.sin(theta) * Math.cos(phi1),
			                           radius * Math.cos(theta),
			                           - radius * Math.sin(theta) * Math.sin(phi1));
			Vector3d lr = new Vector3d(radius * Math.sin(theta) * Math.cos(phi2),
			                           radius * Math.cos(theta),
			                           - radius * Math.sin(theta) * Math.sin(phi2));

			vertices[0] = new Vector3d(uc);
			vertices[1] = new Vector3d(ll);
			vertices[2] = new Vector3d(lr);
			face[index] = new Face(vertices);
			index++;
		}

		// ʂ̑
		double thetaU, thetaL;
		for (int i = 1; i < vdivision - 1; i++) {
			thetaU = Math.toRadians(i * (180.0 / (double)vdivision));
			thetaL = Math.toRadians((i + 1) * (180.0 / (double)vdivision));
			for (int j = 0; j < hdivision; j++) {

				phi1 = Math.toRadians(360.0 / (double)hdivision) * j;
				phi2 = Math.toRadians(360.0 / (double)hdivision) * (j + 1);

				// 4̓_߂
				Vector3d ul = new Vector3d(radius * Math.sin(thetaU) * Math.cos(phi1),
				                           radius * Math.cos(thetaU),
				                           - radius * Math.sin(thetaU) * Math.sin(phi1));
				Vector3d ur = new Vector3d(radius * Math.sin(thetaU) * Math.cos(phi2),
				                           radius * Math.cos(thetaU),
				                           - radius * Math.sin(thetaU) * Math.sin(phi2));
				Vector3d ll = new Vector3d(radius * Math.sin(thetaL) * Math.cos(phi1),
				                           radius * Math.cos(thetaL),
				                           - radius * Math.sin(thetaL) * Math.sin(phi1));
				Vector3d lr = new Vector3d(radius * Math.sin(thetaL) * Math.cos(phi2),
				                           radius * Math.cos(thetaL),
				                           - radius * Math.sin(thetaL) * Math.sin(phi2));

				vertices[0] = new Vector3d(ul);
				vertices[1] = new Vector3d(ll);
				vertices[2] = new Vector3d(lr);
				face[index] = new Face(vertices);
				index++;
				vertices[0] = new Vector3d(lr);
				vertices[1] = new Vector3d(ur);
				vertices[2] = new Vector3d(ul);
				face[index] = new Face(vertices);
				index++;
			}
		}

		// ŉ̑
		theta = Math.toRadians((vdivision - 1) * 180.0 / (double)vdivision);
		for (int j = 0; j < hdivision; j++) {

			phi1 = Math.toRadians(360.0 / (double)hdivision) * j;
			phi2 = Math.toRadians(360.0 / (double)hdivision) * (j + 1);

			Vector3d ul = new Vector3d(radius * Math.sin(theta) * Math.cos(phi1),
			                           radius * Math.cos(theta),
			                           - radius * Math.sin(theta) * Math.sin(phi1));
			Vector3d ur = new Vector3d(radius * Math.sin(theta) * Math.cos(phi2),
			                           radius * Math.cos(theta),
			                           - radius * Math.sin(theta) * Math.sin(phi2));

			vertices[0] = new Vector3d(lc);
			vertices[1] = new Vector3d(ur);
			vertices[2] = new Vector3d(ul);
			face[index] = new Face(vertices);
			index++;
		}
	}

	public void setDiffuse(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setDiffuse(color);
		}
	}

	public void setDiffuse(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setDiffuse(red, green, blue);
		}
	}

	public void setAmbient(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setAmbient(color);
		}
	}

	public void setAmbient(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setAmbient(red, green, blue);
		}
	}

	public void setLineColor(float color[])
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setLineColor(color);
		}
	}

	public void setLineColor(float red, float green, float blue)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].setLineColor(red, green, blue);
		}
	}

	public void persDraw(Vector2d winCenter, Vector2d winScale, Matrix4x4d persM, Matrix4x4d modelM, Matrix4x4d rotM, Vector3d viewPos, Vector3d lightDir, Graphics g)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].persDraw(winCenter, winScale, persM, modelM, rotM, viewPos, lightDir, g);
		}
	}

	public void persDrawLine(Vector2d winCenter, Vector2d winScale, Matrix4x4d persM, Matrix4x4d modelM, Vector3d viewPos, Graphics g)
	{
		for (int i = 0; i < face.length; i++) {
			face[i].persDrawLine(winCenter, winScale, persM, modelM, viewPos, g);
		}
	}
}
