//------------------------------------------------------------//
//                                                            //
//  ʂŕ`悷                                          //
//                                                            //
//	Hiromu Itoh     2006                                      //
//                                                            //
//------------------------------------------------------------//
import java.awt.*;
import java.applet.*;
import java.awt.event.*;


public class TriangleSphere extends Applet implements Runnable
{
	private final double n = 10.0;			// jANbv
	private final double f = 10000.0;		// t@[Nbv
	private final double fov = 60.0;		// piFOVFField Of Viewj

	private Thread thread = null;
	private Image bufferI = null;
	private Graphics bufferG = null;

	// 
	private Sphere sphere = null;

	private float angle = 0.0f;
	private Vector3d axis = new Vector3d(0.0f, 1.0f, 0.0f);

	private Matrix4x4d rotM = new Matrix4x4d();			// ]ϊs
	private Matrix4x4d viewM = new Matrix4x4d();		// _ʒuϊs
	private Matrix4x4d persM = new Matrix4x4d();		// eϊs
	private Vector3d viewPos = new Vector3d(0.0, 0.0, 350.0);		// _ʒu
	private Vector3d lightDir = new Vector3d(-1.0, -1.0, -1.0);		// Cg

	public void init()
	{
		Dimension size = getSize();
		int width = size.width;
		int height = size.height;

		bufferI = createImage(width, height);

		// 쐬
		sphere = new Sphere(100.0, 16, 32);
		sphere.setDiffuse(0.75f, 0.25f, 1.0f);

		// FOVjANbvʂ̕vZ
		// double w = 2.0 * Math.tan((fov / 2.0) * Math.PI / 180.0) * n;
		double w = 2.0 * Math.tan(Math.toRadians(fov / 2.0)) * n;
		// aspectvZ
		double aspect = (double)height / (double)width;
		// jANbvʂ̍vZ
		double h = w * aspect;
		// es쐬
		persM.makePerspective(- w / 2.0, w / 2.0, - h / 2.0, h / 2.0, n, f);

		// _ʒuϊs쐬
		//             _                          _     
		viewM.makeView(new Vector3d(0.0f, 0.0f, 0.0f), viewPos, new Vector3d(0.0f, 1.0f, 0.0f));

		// ]ϊs
		rotM.makeIdentity();

		thread = new Thread(this);
		thread.start();
	}

	public void run()
	{
		try {
			while (true) {
				repaint();

				Thread.sleep(15);
			}
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void update(Graphics g)
	{
		// 2.0]
		angle += 2.5f;
		if (angle > 360.0f) {
			angle -= 360.0f;
		}
		paint(g);
	}

	public void paint(Graphics g)
	{
		Dimension size = getSize();
		int width = size.width;
		int height = size.height;

		if (bufferI == null) {
			bufferI = createImage(width, height);
		}

		if (bufferG == null) {
			bufferG = bufferI.getGraphics();
		}

		// wi`
		bufferG.setColor(new Color(0x000033));
		bufferG.fillRect(0, 0, width, height);

		// EBhE̒SƔ̃TCY
		Vector2d winCenter = new Vector2d(width / 2, height / 2);
		Vector2d winScale = new Vector2d(width / 2, height / 2);

		// ]s쐬
		rotM.makeRotation(axis, angle);
		// ϊsA_ʒuϊs胂fϊs쐬
		Matrix4x4d modelM = viewM.multiplyRight(rotM);
		// 𓧎eŕ`
		sphere.persDraw(winCenter, winScale, persM, modelM, rotM, viewPos, lightDir, bufferG);

		g.drawImage(bufferI, 0, 0, this);
	}
}
