import java.awt.*;
import java.applet.*;
import java.awt.image.*;


public class Render
{
	static int pbuf[];
	static int min[];
	static int max[];
	static int zbuf[];
	static int minz[];
	static int maxz[];

	static int BUFFERW;
	static int BUFFERH;

	Render(int width, int height)
	{
		BUFFERW = width;
		BUFFERH = height;
		pbuf = new int[BUFFERW * BUFFERH];
		min = new int[BUFFERH];
		max = new int[BUFFERH];
		zbuf = new int[BUFFERW * BUFFERH];
		minz = new int[BUFFERH];
		maxz = new int[BUFFERH];
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = 0xff000000;
			zbuf[i] = 2147483647;
		}
	}

	Render(int width, int height, int backColor)
	{
		BUFFERW = width;
		BUFFERH = height;
		pbuf = new int[BUFFERW * BUFFERH];
		min = new int[BUFFERH];
		max = new int[BUFFERH];
		zbuf = new int[BUFFERW * BUFFERH];
		minz = new int[BUFFERH];
		maxz = new int[BUFFERH];
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = backColor;
			zbuf[i] = 2147483647;
		}
	}

	//--------------------------------------------------------------------
	// _OJn
	//
	//--------------------------------------------------------------------
	static final public void beginScene()
	{
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = 0xff000000;
			zbuf[i] = 2147483647;
		}
	}

	static final public void beginScene(int backColor)
	{
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = backColor;
			zbuf[i] = 2147483647;
		}
	}
	
	//--------------------------------------------------------------------
	// _OI
	//
	// Applet applet ...Avbgւ̎Q
	// Graphics offscreen ...ItXN[ւ̎Q
	//--------------------------------------------------------------------
	static final public void endScene(Applet applet,Graphics offscreen)
	{
		offscreen.drawImage(applet.createImage(
			new MemoryImageSource(BUFFERW,BUFFERH,pbuf,0,BUFFERW)),0,0,null);
	}

	static void drawPolygon(Vector3d v1, Vector3d v2, Vector3d v3, int color)
	{
		int top = +2147483647;
		int btm = -2147483648;

		if (top > (int)v1.getY() ) top = (int)v1.getY();
		if (top > (int)v2.getY() ) top = (int)v2.getY();
		if (top > (int)v3.getY() ) top = (int)v3.getY();
		if (btm < (int)v1.getY() ) btm = (int)v1.getY();
		if (btm < (int)v2.getY() ) btm = (int)v2.getY();
		if (btm < (int)v3.getY() ) btm = (int)v3.getY();
		if (top < 0         ) top = 0;
		if (btm > BUFFERH   ) btm = BUFFERH;

		for (int i = top; i < btm; i++){
			min[i] = +2147483647;
			max[i] = -2147483648;
		}

		scanEdge(v1, v2);
		scanEdge(v2, v3);
		scanEdge(v3, v1);

		for (int y = top; y < btm; y++){
			//obt@XVȂXLbv
			if (min[y] == +2147483647) continue;		
			final int offset = y * BUFFERW;
			//lvZ
			int l = (max[y] - min[y]) + 1;
			int addz = (maxz[y] - minz[y]) / l;
			//lݒ
			int z = minz[y];		
			for (int x = min[y]; x <= max[y]; x++, z+=addz){
				if (x < 0 || x >= BUFFERW) continue;	
				int p = offset + x;
				// ZlZobt@菬ΐFZl̃obt@XV
				if (zbuf[p] > z){
					pbuf[p] = color;
					zbuf[p] = z;
				}
			}
		}
	}

	//--------------------------------------------------------------------
	// XLC
	//
	// Vector3d v1 ...n_
	// Vector3d v2 ...I_
	//--------------------------------------------------------------------
	static void scanEdge(Vector3d v1,Vector3d v2)
	{
		// XLC̐ij
		int l = Math.abs((int)(v2.getY() - v1.getY())) + 1;
	
		//lvZiv1v2ɂāj
		// XW
		int addx = (int)((v2.getX() - v1.getX()) * 0xffff) / l;
		// YW
		int addy = (int)((v2.getY() - v1.getY()) * 0xffff) / l;
		// ZW
		int addz = (int)((v2.getZ() - v1.getZ()) * 0xffff) / l;
		
		//lݒ
		int x = (int)(v1.getX() * 0xffff);
		int y = (int)(v1.getY() * 0xffff);
		int z = (int)(v1.getZ() * 0xffff);
			
		//XLiXLCƂɌJԂj
		for (int i = 0; i < l; i++, x+=addx, y+=addy, z+=addz){
			int py = y >> 16;			
			int px = x >> 16;		
			if (py < 0 || py >= BUFFERH) continue;
			// XLCƂXlAZl̍ŏlۑ
			if (min [py] > px){
				min [py] = px;
				minz[py] = z;
			}		
			// XLCƂXlAZl̍őlۑ
			if (max [py] < px){
				max [py] = px;
				maxz[py] = z;
			}
		}
	}
}

