import java.awt.*;
import java.applet.*;
import java.awt.image.*;


public class Render
{
	static private int pbuf[];
	static private int min[];
	static private int max[];
	static private int zbuf[];
	static private int minz[];
	static private int maxz[];
	static private int tbuf[];
	static private int minu[];
	static private int maxu[];
	static private int minv[];
	static private int maxv[];

	static private int BUFFERW;
	static private int BUFFERH;
	static private int TEXTUREW;
	static private int TEXTUREH;
	static private int TEXMASKW;
	static private int TEXMASKH;
	static private int TEXSHIFT;

	Render(int width, int height)
	{
		BUFFERW = width;
		BUFFERH = height;
		pbuf = new int[BUFFERW * BUFFERH];
		min = new int[BUFFERH];
		max = new int[BUFFERH];
		zbuf = new int[BUFFERW * BUFFERH];
		minz = new int[BUFFERH];
		maxz = new int[BUFFERH];
		minu = new int[BUFFERH];
		maxu = new int[BUFFERH];
		minv = new int[BUFFERH];
		maxv = new int[BUFFERH];
		for (int i=0;i<BUFFERW * BUFFERH;i++){
				pbuf[i] = 0xff000000;
				zbuf[i] = 2147483647;
		}
	}

	Render(int width, int height, int backColor)
	{
		BUFFERW = width;
		BUFFERH = height;
		pbuf = new int[BUFFERW * BUFFERH];
		min = new int[BUFFERH];
		max = new int[BUFFERH];
		zbuf = new int[BUFFERW * BUFFERH];
		minz = new int[BUFFERH];
		maxz = new int[BUFFERH];
		minu = new int[BUFFERH];
		maxu = new int[BUFFERH];
		minv = new int[BUFFERH];
		maxv = new int[BUFFERH];
		for (int i=0;i<BUFFERW * BUFFERH;i++){
				pbuf[i] = backColor;
				zbuf[i] = 2147483647;
		}
	}

	//--------------------------------------------------------------------
	//eNX`̐ݒ
	//
	//--------------------------------------------------------------------
	static final public void setTexture(Image texture)
	{
		TEXTUREW  = texture.getWidth (null);
		TEXTUREH  = texture.getHeight(null);
		TEXMASKW  = TEXTUREW - 1;
		TEXMASKH  = TEXTUREH - 1;
		
		TEXSHIFT = 0;
		for (int i=0;i<32;i++)
			if (((TEXMASKW>>i)&1) > 0)
				TEXSHIFT++;
		
		tbuf = new int[TEXTUREW * TEXTUREH];
		
		PixelGrabber pg = new PixelGrabber(texture,0,0,TEXTUREW,TEXTUREH,tbuf,0,TEXTUREW);
		
		try {
			pg.grabPixels();
		} catch (InterruptedException e) {}
	}

	//--------------------------------------------------------------------
	// _OJn
	//
	//--------------------------------------------------------------------
	static final public void beginScene()
	{
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = 0xff000000;
			zbuf[i] = 2147483647;
		}
	}

	static final public void beginScene(int backColor)
	{
		for (int i=0;i<BUFFERW * BUFFERH;i++){
			pbuf[i] = backColor;
			zbuf[i] = 2147483647;
		}
	}
	
	//--------------------------------------------------------------------
	// _OI
	//
	// Applet applet ...Avbgւ̎Q
	// Graphics offscreen ...ItXN[ւ̎Q
	//--------------------------------------------------------------------
	static final public void endScene(Applet applet,Graphics offscreen)
	{
		offscreen.drawImage(applet.createImage(
			new MemoryImageSource(BUFFERW,BUFFERH,pbuf,0,BUFFERW)),0,0,null);
	}

	static void drawPolygon(Vector3d v1, Vector3d v2, Vector3d v3, int color)
	{
		int top = +2147483647;
		int btm = -2147483648;

		if (top > (int)v1.getY() ) top = (int)v1.getY();
		if (top > (int)v2.getY() ) top = (int)v2.getY();
		if (top > (int)v3.getY() ) top = (int)v3.getY();
		if (btm < (int)v1.getY() ) btm = (int)v1.getY();
		if (btm < (int)v2.getY() ) btm = (int)v2.getY();
		if (btm < (int)v3.getY() ) btm = (int)v3.getY();
		if (top < 0         ) top = 0;
		if (btm > BUFFERH   ) btm = BUFFERH;

		for (int i = top; i < btm; i++){
			min[i] = +2147483647;
			max[i] = -2147483648;
		}

		scanEdge(v1, v2);
		scanEdge(v2, v3);
		scanEdge(v3, v1);

		for (int y = top; y < btm; y++){
			//obt@XVȂXLbv
			if (min[y] == +2147483647) continue;		
			final int offset = y * BUFFERW;
			//lvZ
			int l = (max[y] - min[y]) + 1;
			int addz = (maxz[y] - minz[y]) / l;
			//lݒ
			int z = minz[y];		
			for (int x = min[y]; x <= max[y]; x++, z+=addz){
				if (x < 0 || x >= BUFFERW) continue;	
				int p = offset + x;
				// ZlZobt@菬ΐFZl̃obt@XV
				if (zbuf[p] > z){
					pbuf[p] = color;
					zbuf[p] = z;
				}
			}
		}
	}

	static void drawPolygon(Vector3d v1, Vector3d v2, Vector3d v3,
	                        Vector2d uv1, Vector2d uv2, Vector2d uv3, int color)
	{
		int top = +2147483647;
		int btm = -2147483648;

		if (top > (int)v1.getY() ) top = (int)v1.getY();
		if (top > (int)v2.getY() ) top = (int)v2.getY();
		if (top > (int)v3.getY() ) top = (int)v3.getY();
		if (btm < (int)v1.getY() ) btm = (int)v1.getY();
		if (btm < (int)v2.getY() ) btm = (int)v2.getY();
		if (btm < (int)v3.getY() ) btm = (int)v3.getY();
		if (top < 0         ) top = 0;
		if (btm > BUFFERH   ) btm = BUFFERH;

		for (int i = top; i < btm; i++){
			min[i] = +2147483647;
			max[i] = -2147483648;
		}

		scanEdge(v1, v2, uv1, uv2);
		scanEdge(v2, v3, uv2, uv3);
		scanEdge(v3, v1, uv3, uv1);

		for (int y = top; y < btm; y++){
			//obt@XVȂXLbv
			if (min[y] == +2147483647) continue;		
			final int offset = y * BUFFERW;
			//lvZ
			int l = (max[y] - min[y]) + 1;
			int addz = (maxz[y] - minz[y]) / l;
			int addu = (maxu[y] - minu[y]) / l;
			int addv = (maxv[y] - minv[y]) / l;
			//lݒ
			int z = minz[y];		
			int u = minu[y];
			int v = minv[y];
			for (int x = min[y]; x <= max[y]; x++, z+=addz,u+=addu,v+=addv){
				if (x < 0 || x >= BUFFERW) continue;	
				int p = offset + x;
				// ZlZobt@菬ΐFZl̃obt@XV
				if (zbuf[p] > z){

					int r = (color & 0xff0000) >> 16;
					int g = (color & 0x00ff00) >> 8;
					int b = (color & 0x0000ff);

					//eNZ擾
					int texel = tbuf[(((v>>16) & TEXMASKH)<<TEXSHIFT) + ((u>>16) & TEXMASKW)];
					
					//eNZRGBƖʂ̐F⊮RGBZB
					int tr = (r * ((texel & 0xff0000)>>16) )>>8;
					int tg = (g * ((texel & 0x00ff00)>>8 ) )>>8;
					int tb = (b * ((texel & 0x0000ff)    ) )>>8;
					if (tr > 255) tr = 255;
					if (tg > 255) tg = 255;
					if (tb > 255) tb = 255;
					
					pbuf[p] = (tr<<16) | (tg<<8) | tb | 0xff000000;
					zbuf[p] = z;
				}
			}
		}
	}

	//--------------------------------------------------------------------
	// XLC
	//
	// Vector3d v1 ...n_
	// Vector3d v2 ...I_
	//--------------------------------------------------------------------
	static void scanEdge(Vector3d v1,Vector3d v2)
	{
		// XLC̐ij
		int l = Math.abs((int)(v2.getY() - v1.getY())) + 1;
	
		//lvZiv1v2ɂāj
		// XW
		int addx = (int)((v2.getX() - v1.getX()) * 0xffff) / l;
		// YW
		int addy = (int)((v2.getY() - v1.getY()) * 0xffff) / l;
		// ZW
		int addz = (int)((v2.getZ() - v1.getZ()) * 0xffff) / l;
		
		//lݒ
		int x = (int)(v1.getX() * 0xffff);
		int y = (int)(v1.getY() * 0xffff);
		int z = (int)(v1.getZ() * 0xffff);
			
		//XLiXLCƂɌJԂj
		for (int i = 0; i < l; i++, x+=addx, y+=addy, z+=addz){
			int py = y >> 16;			
			int px = x >> 16;		
			if (py < 0 || py >= BUFFERH) continue;
			// XLCƂXlAZl̍ŏlۑ
			if (min [py] > px){
				min [py] = px;
				minz[py] = z;
			}		
			// XLCƂXlAZl̍őlۑ
			if (max [py] < px){
				max [py] = px;
				maxz[py] = z;
			}
		}
	}
	//--------------------------------------------------------------------
	// XLC
	//
	// Vector3d v1 ...n_
	// Vector3d v2 ...I_
	// Vector2d uv1 ...n_ieNX`Wj
	// Vector2d uv2 ...I_ieNX`Wj
	//--------------------------------------------------------------------
	static void scanEdge(Vector3d v1,Vector3d v2, Vector2d uv1, Vector2d uv2)
	{
		// XLC̐ij
		int l = Math.abs((int)(v2.getY() - v1.getY())) + 1;
	
		//lvZiv1v2ɂāj
		// XW
		int addx = (int)((v2.getX() - v1.getX()) * 0xffff) / l;
		// YW
		int addy = (int)((v2.getY() - v1.getY()) * 0xffff) / l;
		// ZW
		int addz = (int)((v2.getZ() - v1.getZ()) * 0xffff) / l;
		// UW
		int addu = (int)((uv2.getX() - uv1.getX())*TEXTUREW * 0xffff) / l;
		// VW
		int addv = -(int)((uv2.getY() - uv1.getY())*TEXTUREH * 0xffff) / l;
		
		//lݒ
		int x = (int)(v1.getX() * 0xffff);
		int y = (int)(v1.getY() * 0xffff);
		int z = (int)(v1.getZ() * 0xffff);
		int u = (int)(uv1.getX()*TEXTUREW * 0xffff);
		int v = (int)((1.0-uv1.getY())*TEXTUREH * 0xffff);
			
		//XLiXLCƂɌJԂj
		for (int i = 0; i < l; i++, x+=addx, y+=addy, z+=addz, u+=addu, v+=addv){
			int py = y >> 16;			
			int px = x >> 16;		
			if (py < 0 || py >= BUFFERH) continue;
			// XLCƂXlAZl̍ŏlۑ
			if (min [py] > px){
				min [py] = px;
				minz[py] = z;
				minu[py] = u;
				minv[py] = v;
			}		
			// XLCƂXlAZl̍őlۑ
			if (max [py] < px){
				max [py] = px;
				maxz[py] = z;
				maxu[py] = u;
				maxv[py] = v;
			}
		}
	}
}
